#include "stm32f10x.h"
#include "main.h"
#include "key.h"
#include "store_data_in_flash.h"
#include "ir_in_out.h"

// ʼGPIOźж
void Key_Init(void) {
    // GPIOAʱ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_AFIO, ENABLE);
	// JTAG
	GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable, ENABLE);
    
    // ðGPIOΪ
    GPIO_InitTypeDef GPIO_InitStructure;
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 | GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7 | GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU; // ģʽ
    GPIO_Init(GPIOA, &GPIO_InitStructure);
    
    // ⲿжϿ
    EXTI_InitTypeDef EXTI_InitStructure;
	
    // ÿж
	int EXTI_Line_IRQ;		//ж/IRQ
	unsigned int i;
    for (i = 1; i < 14; i++) {
		if (i==13){i += 2;}
        EXTI_Line_IRQ = (1 << i);
        
        // ѡӦGPIOźж
        GPIO_EXTILineConfig(GPIO_PortSourceGPIOA, GPIO_PinSource0 + i);
        
        EXTI_InitStructure.EXTI_Line = EXTI_Line_IRQ;
        EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
        EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling; // ½ش
        EXTI_InitStructure.EXTI_LineCmd = ENABLE;
        EXTI_Init(&EXTI_InitStructure);
    }
    
    // ǶжϿNVIC
    NVIC_InitTypeDef NVIC_InitStructure;
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);	//ȼ
    for (i = 1; i < 6; i++)				//ùܼNVIC
	{
		if(i == 5){i = 17;}
		 
        NVIC_InitStructure.NVIC_IRQChannel = EXTI0_IRQn + i;
        NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
        NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
        NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
        NVIC_Init(&NVIC_InitStructure);
    }
	//ѡNVIC
	NVIC_InitStructure.NVIC_IRQChannel = EXTI15_10_IRQn; 
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
}
void EXTI1_IRQHandler(void) {
    if (EXTI_GetITStatus(EXTI_Line1) != RESET) 
	{
		Function_KEY = 0;			//°־λ
		ButtonAction(GPIO_Pin_1);				//ܰ
        EXTI_ClearITPendingBit(EXTI_Line1);		// жϱ־λ
    }
}

void EXTI2_IRQHandler(void) {
    if (EXTI_GetITStatus(EXTI_Line2) != RESET) 
	{
		Function_KEY = 1;			//°־λ
		ButtonAction(GPIO_Pin_2);				//ܰ
        EXTI_ClearITPendingBit(EXTI_Line2);		// жϱ־λ
    }
}

void EXTI3_IRQHandler(void) {
    if (EXTI_GetITStatus(EXTI_Line3) != RESET) 
	{
		Function_KEY = 2;			//°־λ
		ButtonAction(GPIO_Pin_3);				//ܰ
        EXTI_ClearITPendingBit(EXTI_Line3);		// жϱ־λ
    }
}

void EXTI4_IRQHandler(void) {
    if (EXTI_GetITStatus(EXTI_Line4) != RESET) 
	{
		Function_KEY = 3;			//°־λ
		ButtonAction(GPIO_Pin_4);				//ܰ
        EXTI_ClearITPendingBit(EXTI_Line4);		// жϱ־λ
    }
}

void EXTI9_5_IRQHandler(void) {
	int KEY_EXTI_Line;			//жʱ洢
	for(int l=0; l<5; l++)		//ұµİ//ж
	{
		KEY_EXTI_Line = (EXTI_Line5 << l);		//ȷж
		if (EXTI_GetITStatus(KEY_EXTI_Line) != RESET) 
		{
			int KEY_GPIO_p = GPIO_Pin_5 << l;		//ȷGPIO
			Function_KEY = 4+l;			//°־λ
			ButtonAction(KEY_GPIO_p);				//ܰ
			EXTI_ClearITPendingBit(KEY_EXTI_Line);		// жϱ־λ
			l = 5;			//˳
		}
	}
}

//ܰ
void ButtonAction(int KEY_GPIO_Pin)
{
	int i = 0;
	if (EXTI_GetITStatus(EXTI_Line10) != RESET){i=1;}		//ѧϰģʽӦ
	if (EXTI_GetITStatus(EXTI_Line11) != RESET){i=1;}		//ѧϰģʽӦ
	if (EXTI_GetITStatus(EXTI_Line12) != RESET){i=1;}		//ѧϰģʽӦ
	if (EXTI_GetITStatus(EXTI_Line15) != RESET){i=1;}		//ѧϰģʽӦ
	delay_ms(20);		//ȥ
	if(GPIO_ReadInputDataBit(GPIOA, KEY_GPIO_Pin) == 0 && i==0)
	{
		unsigned int KEY_Data_Address = FLASH_START_ADDRESS + ((9 * model + Function_KEY)*1024);	//ȡ洢λ
		IR_Output(KEY_Data_Address);					//ź
	}

}

// 豸ѡжϷ
void EXTI15_10_IRQHandler(void) {
	int KEY_EXTI_Line;			//жʱ洢
	for(int l=0; l<4; l++)		//ұµİ//ж
	{
		if(l==3){l+=2;}
		KEY_EXTI_Line = (EXTI_Line10 << l);		//ȷж
		if (EXTI_GetITStatus(KEY_EXTI_Line) != RESET)	//ȡж״̬
		{
			int KEY_GPIO_p = GPIO_Pin_10 << l;		//ȷGPIO
			if(l<3){model = l;}				//ѡ豸
			else{model = 3;}
			GPIO_SetBits(GPIOB, (GPIO_Pin_5 << model));		//ָʾǰµ豸л
			for(int i=0; i<2000; i++)					//20ϲӦָ
			{
				delay_ms(10);
				if(i>1000){GPIO_SetBits(GPIOB,(GPIO_Pin_5 << model));}		//10ϽѧϰģʽƳ
				else if(i>100){GPIO_ResetBits(GPIOB,(GPIO_Pin_5 << model));}		//ѡ豸ָʾ״̬ر
				if(Function_KEY == WAITING_TO_PRESS){i=1500;}			//ܼ־λȴʱֱӽѧϰȴ
				if(GPIO_ReadInputDataBit(GPIOA, KEY_GPIO_p) == 1 && i>1000)		//10Ͻѧϰģʽ
				{
					int j;
					Function_KEY = WAITING_TO_PRESS;	//ܼ־λΪȴ
					for(j=0; j<1500; j++)		//ȴҪѧϰİȴԼ15
					{
						delay_ms(10);
						if(Function_KEY != WAITING_TO_PRESS){j = 1500;}		//йܼ˳ȴ
						if(GPIO_ReadInputDataBit(GPIOA, KEY_GPIO_p) == 0)	//ٴΰл˳ȴ
						{
							delay_ms(20);	//ȥ
							if(GPIO_ReadInputDataBit(GPIOA, KEY_GPIO_p) == 0){j = 1500;}
						}
					}
					if(Function_KEY != WAITING_TO_PRESS){j=0;}		//жǷѧϰ
					else{Function_KEY = FUNCTION_KEY_EMPTY;}							//ѧϰ״̬־λ
					while (j<10)				//ѧϰ10δ˳ѧϰ
					{
						j++;
						delay_ms(300);
						j += IR_Data_Input(KEY_GPIO_p);	//ѧϰݺ
						if(j>=100)
						{
							StoreDataInFlash(9*model+Function_KEY);			//ݵflash
							Function_KEY = WAITING_TO_PRESS;				//״̬Ϊȴѧϰһ
						}
					}
					i = 2000;					//˳жǷ񳤰
				}
				if(GPIO_ReadInputDataBit(GPIOA, KEY_GPIO_p) == 1 && i<=1000)	//10ɿӦѧϰָ
				{
					i = 2000;					//˳жǷ񳤰
					Function_KEY = FUNCTION_KEY_EMPTY;		//ѧϰ״̬־λ
				}	
			}
			GPIO_ResetBits(GPIOB,(GPIO_Pin_5 << model));		//˳жϹرָʾ
			if(Function_KEY != WAITING_TO_PRESS || KEY_EXTI_Line != EXTI_Line10){EXTI_ClearITPendingBit(EXTI_Line10);}		// жϱ־λ
			if(Function_KEY != WAITING_TO_PRESS || KEY_EXTI_Line != EXTI_Line11){EXTI_ClearITPendingBit(EXTI_Line11);}		// жϱ־λ
			if(Function_KEY != WAITING_TO_PRESS || KEY_EXTI_Line != EXTI_Line12){EXTI_ClearITPendingBit(EXTI_Line12);}		// жϱ־λ
			if(Function_KEY != WAITING_TO_PRESS || KEY_EXTI_Line != EXTI_Line15){EXTI_ClearITPendingBit(EXTI_Line15);}		// жϱ־λ
			l = 4;		//˳
		}
	}
}
